diff --git a/contrib/pg_upgrade/util.c b/contrib/pg_upgrade/util.c
new file mode 100644
index 1c71204..2c0dfd6
*** a/contrib/pg_upgrade/util.c
--- b/contrib/pg_upgrade/util.c
*************** pg_log(eLogType type, char *fmt,...)
*** 78,84 ****
  	va_end(args);
  
  	/* PG_VERBOSE is only output in verbose mode */
! 	if (type != PG_VERBOSE || log_opts.verbose)
  	{
  		fwrite(message, strlen(message), 1, log_opts.internal);
  		/* if we are using OVERWRITE_MESSAGE, add newline to log file */
--- 78,85 ----
  	va_end(args);
  
  	/* PG_VERBOSE is only output in verbose mode */
! 	/* fopen() on log_opts.internal might have failed, so check it */
! 	if ((type != PG_VERBOSE || log_opts.verbose) && log_opts.internal != NULL)
  	{
  		fwrite(message, strlen(message), 1, log_opts.internal);
  		/* if we are using OVERWRITE_MESSAGE, add newline to log file */
